<template>
  <div id="main_pending">
    
  </div>
</template>
<script>
import axios from "axios";
export default {
  inject: ["reload"],
  data() {
    return {
      preserve: [],
      putaside: [],
      Formrendering: [], //表格里面首次渲染的数据
      backlogRight: "", //主题框的v-model
      backlogProposer: "", //申请框的v-model
      ChildList:'',//按部门的穿梭框的v-model
      dialogVisible: false, //弹出框是否弹出
      activeName: "first", //标签页默认选中第一个
      Storage: [], //储存按角色为树形的用户数据
      Shuttle: "", //按角色的穿梭框的v-model
      userSublist: [], //按角色储存子列表的数据
      DepartmentSublist:[],//按部门储存子列表数据
      //按部门选择的节点展示
      props: {
        label: "name",
        children: "zones",
        isLeaf: "leaf"
      }
    };
  },
  created() {
    this.navigation();
    this.avigraph();
    this.flowcenters();
    this.selectbox();
  },
  methods: {
    //服务器返回待办导航的结果
    navigation() {
      axios({
        url: "obpm" + "/runtime/flowcenters/navs/pendings",
        method: "get",
        params: {
          applicationId: "HdPeBqYwJyFyjHkhZu3"
        }
      })
        .then(res => {
          let newData = res.data.data[0].pendingFlowList.map(item => {
            return {
              id: item.id,
              name: item.name,
              num: item.num
            };
          });
          this.preserve = newData;
        })
        .catch(() => {

        });
    },
    avigraph() {
      axios({
        url: "obpm" + "/runtime/flowcenters/navs/pendings",
        method: "get",
        params: {
          applicationId: "HdPeBqYwJyFyjHkhZu3"
        }
      })
        .then(res => {
          let newData = res.data.data.map(item => {
            return {
              id: item.id,
              name: item.name
            };
          });
          this.putaside = newData;
        })
        .catch(() => {
  
        });
    },
    //获取待办事项
    flowcenters() {
      axios({
        url: "obpm" + "/runtime/HdPeBqYwJyFyjHkhZu3/flowcenters/pendings",
        method: "get",
        params: {
          title: this.backlogRight,
          linesPerPage: 10,
          pageNo: 1
        }
      })
        .then(res => {
          let newData = res.data.data.datas.map(item => {
            return {
              docId: item.docId,
              initiator: item.initiator,
              initiatorDept: item.initiatorDept,
              lastProcessTime: item.lastProcessTime.substring(5, 10),
              lastFlowOperation: (item.lastFlowOperation = "流转"),
              stateLabel: item.stateLabel
            };
          });
          this.Formrendering = newData;
        })
        .catch(() => {
        });
    },
    //清除主题框和申请框里面面对数据
    eliminating() {
      this.backlogRight = "";
      this.backlogProposer = "";
    },
    //分页请求
    paging(value) {
      axios({
        url: "obpm" + "/runtime/HdPeBqYwJyFyjHkhZu3/flowcenters/pendings",
        method: "get",
        params: {
          linesPerPage: 10,
          pageNo: value
        }
      })
        .then(res => {
          let newData = res.data.data.datas.map(item => {
            return {
              docId: item.docId,
              initiator: item.initiator,
              initiatorDept: item.initiatorDept,
              lastProcessTime: item.lastProcessTime.substring(5, 10),
              lastFlowOperation: (item.lastFlowOperation = "流转"),
              stateLabel: item.stateLabel
            };
          });
          this.Formrendering = newData;
        })
        .catch(() => {

        });
    },
    //主题框的出发事件
    activate() {
      if (this.backlogRight.length === 0) {
        this.reload();
      }
    },
    //点击左侧导航触发待办事项
    omniselector(id) {
      axios({
        url: "obpm" + "/runtime/HdPeBqYwJyFyjHkhZu3/flowcenters/pendings",
        method: "get",
        params: {
          flowId: id
        }
      })
        .then(res => {
          let newData = res.data.data.datas.map(item => {
            return {
              docId: item.docId,
              initiator: item.initiator,
              initiatorDept: item.initiatorDept,
              lastFlowOperation: (item.lastFlowOperation = "流程"),
              lastProcessTime: item.lastProcessTime.substring(5, 10),
              stateLabel: item.stateLabel
            };
          });
          this.Formrendering = newData;
        })
        .catch(() => {

        });
    },
    //点击重新加载表格数据
    primaryNavigationSystem() {
      axios({
        url: "obpm" + "/runtime/HdPeBqYwJyFyjHkhZu3/flowcenters/pendings",
        method: "get",
        params: {
          title: this.backlogRight,
          linesPerPage: 10,
          pageNo: 1
        }
      })
        .then(res => {
          let newData = res.data.data.datas.map(item => {
            return {
              docId: item.docId,
              initiator: item.initiator,
              initiatorDept: item.initiatorDept,
              lastProcessTime: item.lastProcessTime.substring(5, 10),
              lastFlowOperation: (item.lastFlowOperation = "流转"),
              stateLabel: item.stateLabel
            };
          });
          this.Formrendering = newData;
        })
        .catch(() => {
        });
    },
    //点击添加弹出
    AddPopup() {
      this.dialogVisible = !this.dialogVisible;
    },
    //获取以角色为树形结构的用户集合
    selectbox() {
      axios({
        url: "obpm" + "/runtime/HdPeBqYwJyFyjHkhZu3/users/selectbox/role",
        method: "get"
      })
        .then(res => {
          let newData = res.data.data.datas.map(item => {
            return {
              id: item.id,
              name: item.name
            };
          });
          this.Storage = newData;
        })
        .catch(() => {

        });
    },
    //获取角色列表的子列表
    selected(id) {
      axios({
        url: "obpm" + "/runtime/HdPeBqYwJyFyjHkhZu3/users/selectbox/role",
        method: "get",
        params: {
          roleId: id
        }
      })
        .then(res => {
          let newData = res.data.data.datas.map(item => {
            return {
              id: item.id,
              name: item.name
            };
          });
          this.userSublist = newData;
        })
        .catch(() => {

        });
    },
    loadNode(node, resolve) {
      if (node.level === 0) {
        axios({
          url:
            "obpm" + "/portal/component/user/getDepartmentsByParentId.action",
          method: "get",
          params: {
            parentId: ""
          }
        })
          .then(res => {
            resolve(res.data.data);
          })
          .catch(() => {

          });
      } else {
        axios({
          url:
            "obpm" + "/portal/component/user/getDepartmentsByParentId.action",
          method: "get",
          params: {
            parentId: node.key
          }
        })
          .then(res => {
            resolve(res.data.data);
          })
          .catch(() => {

          });
      }
    },
    //获取部门列表的子列表
    handelDepartment(event) {
      axios({
        url: "obpm" + "/runtime/HdPeBqYwJyFyjHkhZu3/users/selectbox/department",
        method: "get",
        params: {
          deptId: event.id
        }
      })
        .then(res => {
          let newData = res.data.data.datas.map(item => {
            return {
              id: item.id,
              name: item.name,
              parentId: item.parentId
            };
          });
          this.DepartmentSublist = newData;
        })
        .catch(() => {
        });
    }
  }
};
</script>
<style lang="scss" scoped>
#main_pending {
  width: 100%;
  min-height: 200px;
  background: white;
  overflow: hidden;
  box-shadow: 0 0 10px #ccc;
  .main_pending-left {
    float: left;
    width: 150px;
    height: 450px;
    overflow-x: auto;
    border-right: 1px solid #ccc;
    .main_pending-left-dyspepsia {
      width: 100%;
      height: 45px;
      overflow: hidden;
      overflow-y: hidden;
      padding: 15px 20px;
      span {
        float: left;
        width: 80px;
        overflow: hidden; /*自动隐藏文字*/
        text-overflow: ellipsis; /*文字隐藏后添加省略号*/
        white-space: nowrap; /*强制不换行*/
        color: #9c9d9f;
        cursor: pointer;
      }
      a {
        float: right;
        width: 20px;
        height: 20px;
        border: 1px solid #ccc;
        border-radius: 50%;
        b {
          display: block;
          text-align: center;
          font-weight: 100;
          font-size: 12px;
          line-height: 20px;
          color: #9c9d9f;
        }
      }
    }
    .main_pending-left-dyspepsia:hover span {
      color: #6bbae9;
    }
    .main_pending-left-dyspepsia:hover a {
      border: none;
      background: #fc4d54;
    }
    .main_pending-left-dyspepsia:hover b {
      color: white;
      font-weight: 600;
    }
    ul {
      width: 100%;
      min-height: 30px;
      .soft-heading {
        width: 149px;
        height: 30px;
        cursor: pointer;
        overflow: hidden;
        span {
          float: left;
          width: 80px;
          overflow: hidden; /*自动隐藏文字*/
          text-overflow: ellipsis; /*文字隐藏后添加省略号*/
          white-space: nowrap; /*强制不换行*/
          margin-left: 20px;
          line-height: 30px;
          font-size: 12px;
          color: #767682;
        }
        a {
          float: right;
          margin-right: 20px;
          width: 20px;
          height: 20px;
          border: 1px solid #ccc;
          border-radius: 50%;
          margin-top: 5px;
          overflow: hidden;
          b {
            display: block;
            text-align: center;
            font-weight: 100;
            font-size: 12px;
            line-height: 20px;
            color: #9c9d9f;
          }
        }
      }
      .soft-heading:hover span {
        color: #46d2db;
      }
      .soft-heading:hover a {
        border: none;
        background: #fc4d54;
      }
      .soft-heading:hover b {
        color: white;
        font-weight: 600;
      }
    }
  }
  .main_pending-right {
    float: left;
    width: 950px;
    height: 450px;
    .main_pending-right-theme {
      width: 100%;
      height: 12%;
      overflow: hidden;
      .main_pending-right-right {
        float: right;
        width: 70%;
        height: 100%;
        .el-input {
          width: 200px;
          height: 40px;
          margin-top: 7px;
          margin-right: 5px;
        }
      }
    }
    .el-table {
      cursor: pointer;
    }
    .el-pagination {
      margin-left: 330px;
    }
    .first-box {
      width: 100%;
      min-height: 300px;
      overflow: hidden;
      position: relative;
      .first-item {
        float: left;
        width: 200px;
        min-height: 300px;
        margin-right: 10px;
        border: 1px solid #ccc;
        span {
          display: block;
          width: 100%;
          height: 40px;
          font-size: 12px;
          padding-left: 20px;
          padding-top: 14px;
          box-sizing: border-box;
          border-bottom: 1px solid #ccc;
        }
        ul {
          width: 100%;
          min-height: 40px;
          li {
            width: 100%;
            min-height: 40px;
            border-bottom: 1px solid #ccc;
            span {
              display: block;
            }
          }
          li:hover span {
            color: #46d2db;
            cursor: pointer;
          }
        }
        .first-list {
          width: 100%;
          min-height: 300px;
        }
      }
      .el-transfer-panel {
        border: 1px solid #ebeef5;
        border-radius: 4px;
        overflow: hidden;
        background: #fff;
        display: inline-block;
        vertical-align: middle;
        width: 200px;
        max-height: 100%;
        -webkit-box-sizing: border-box;
        box-sizing: border-box;
      }
    }
  }
}
</style>


